#pragma once


//=====================================DEFINITIONS================================
#define MAXPACKEDBUFFER 2048

//=====================================STRUCTURES================================

typedef struct _ENVPOINT
{
	WORD	wX;
	WORD	wY;
	BYTE	btFlags;
}ENVPOINT;

typedef struct _ENVELOPE
{
	WORD	wAttackTime;
	WORD	wDecayTime;
	WORD	wSustainLevel;
	WORD	wReleaseTime;
	BYTE	btADSRSubdivide;
	BYTE	btADSRFlags;
		
	WORD wNumPoints;
	ENVPOINT	* lpEnvPoints;

}ENVELOPE;

typedef struct _LEVEL
{
	DWORD dwNumSamples;
	DWORD dwLoopBegin;
	DWORD dwLoopEnd;
	DWORD dwSampsPerSecond;
	BYTE btRootNote;

	LPWORD lpwWaveData;

}LEVEL;

typedef struct _WAVT_ENTRY
{
	WORD	wIndex;
	char	acFullName[255];
	char	acName[255];
	float	volume;
	BYTE	btFlags;

	
	WORD	wNumEnvelopes;
	ENVELOPE * lpEnvelopes;
	
	BYTE	btNumLevels;
	LEVEL	* lpLevels;

}WAVT_ENTRY;

typedef struct _COMPRESSIONVALUES
{
	WORD	wSum1;
	WORD	wSum2;
	WORD	wResult;

	LPWORD	lpwTempData;
}COMPRESSIONVALUES;

typedef struct _WAVEUNPACK
{
	FILE* hFile;
	BYTE abtPackedBuffer[MAXPACKEDBUFFER];
	DWORD dwCurIndex;
	DWORD dwCurBit;

	DWORD dwBytesInBuffer;
	DWORD dwMaxBytes;
	DWORD dwBytesInFileRemain;

}WAVEUNPACK;


BOOL InitWaveUnpack(WAVEUNPACK * waveunpackinfo,FILE* hFile,DWORD dwSectionSize);
BOOL DecompressWave(WAVEUNPACK * unpackinfo,LPWORD lpwOutputBuffer, DWORD dwNumSamples,BOOL bStereo);

